> This page is for Developers.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://zuora.ferndocs.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://zuora.ferndocs.com/_mcp/server.

# Reject a payment

POST https://rest.test.zuora.com/v1/gateway-settlement/payments/{payment-key}/reject
Content-Type: application/json

If the Asynchronous Payment Statuses feature is not enabled, this
API operation sets the Gateway State field of the payment to `FailedToSettle`,
creates a refund for the payment amount, and returns the Refund object as response.

If the Asynchronous Payment Statuses feature is enabled, for ACH and Bank Transfer
payments, this API operation sets the Payment Status field to `Error` and the
Gateway State field to `FailedToSettle`, and unapply the payment if it is already
applied.

If the reason code "Payment Rejection" is active in the Reason Codes list, the reason code of the external refund is set to "Payment Rejection". Otherwise, the default reason code in the list is used.

Reference: https://zuora.ferndocs.com/developers/api-reference/zuora-api/payments/payment-gateway-reconciliation/post-reject-payment

## Authentication

- `Authorization` header (bearer token, required) — Use `Bearer {{token}}` in the `Authorization` header for authentication.

## Servers

- `https://rest.test.zuora.com` (US Developer & Central Sandbox (incl. Test Drive), default)
- `https://rest.sandbox.na.zuora.com` (US API Sandbox Cloud 1)
- `https://rest.apisandbox.zuora.com` (US API Sandbox Cloud 2)
- `https://rest.na.zuora.com` (US Production Cloud 1)
- `https://rest.zuora.com` (US Production Cloud 2)
- `https://rest.test.eu.zuora.com` (EU Developer & Central Sandbox)
- `https://rest.sandbox.eu.zuora.com` (EU API Sandbox)
- `https://rest.eu.zuora.com` (EU Production)
- `https://rest.test.ap.zuora.com` (APAC Developer & Central Sandbox)
- `https://rest.ap.zuora.com` (APAC Production)

## Request

### Path parameters

- `payment-key` (string, required) — The payment number starting with "P-" or the unique payment ID.

### Headers

- `Idempotency-Key` (string, optional) — Specify a unique idempotency key if you want to perform an idempotent POST or PATCH request. Do not use this header in other request types. With this header specified, the Zuora server can identify subsequent retries of the same request using this value, which prevents the same operation from being performed multiple times by accident.
- `Accept-Encoding` (string, optional) — Include the `Accept-Encoding: gzip` header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response. If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a `Content-Encoding` header with the compression algorithm so that your client can decompress it.
- `Content-Encoding` (string, optional) — Include the `Content-Encoding: gzip` header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload.
- `Zuora-Track-Id` (string, optional) — A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue. The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (`:`), semicolon (`;`), double quote (`"`), and quote (`'`).
- `Zuora-Entity-Ids` (string, optional) — An entity ID. If you have [Zuora Multi-entity](https://knowledgecenter.zuora.com/BB_Introducing_Z_Business/Multi-entity) enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header.
- `Zuora-Org-Ids` (string, optional) — Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header. The IDs must be a sub-set of the user's accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user's accessible orgs.
- `Zuora-Version` (string, optional) — The minor API version. For a list of available minor versions, see [API upgrades](https://developer.zuora.com/v1-api-reference/api-upgrades/).

### Body (application/json)

This endpoint expects a POSTRejectPaymentRequest.

- `gatewayReconciliationReason` (string, optional) — The reason of gateway reconciliation.
- `gatewayReconciliationStatus` (string, optional) — The status of gateway reconciliation.
- `gatewayResponse` (string, optional) — The transaction response returned by the gateway for this transaction. If the transaction was declined, this reason is provided in the message.
- `gatewayResponseCode` (string, optional) — Response message Code returned by the gateway about the transaction status.
- `referenceId` (string, optional) — Unique Id generated by the gateway for each transaction. Use this ID to find the respective Zuora Payment ID.
- `secondReferenceId` (string, optional) — The second reference Id. Some gateway uses two unique transaction IDs.
- `settledOn` (string, optional) — The date and time of the transaction settlement. The format is `yyyy-mm-dd hh:mm:ss`.

## Response

### 200

OK

- `accountId` (string, optional) — The ID of the customer account that the payment is for.
- `amount` (double, optional) — The total amount of the payment.
- `cancelledOn` (string, optional) — The date and time when the payment was cancelled, in `yyyy-mm-dd hh:mm:ss` format.
- `comment` (string, optional, nullable) — Comments about the payment.
- `createdById` (string, optional) — The ID of the Zuora user who created the refund.
- `createdDate` (string, optional) — The date and time when the chargeback is created, in `yyyy-mm-dd hh:mm:ss` format. For example, 2019-03-01 15:31:10.
- `creditMemoId` (string, optional) — The ID of the credit memo that is refunded.
- `financeInformation` (PostRejectPaymentResponseFinanceInformation, optional) — Container for the finance information related to the refund.
- `gatewayId` (string, optional) — The ID of the gateway instance that processes the payment.
- `gatewayReconciliationReason` (string, optional) — The reason of gateway reconciliation.
- `gatewayReconciliationStatus` (string, optional) — The status of gateway reconciliation.
- `gatewayResponse` (string, optional) — The message returned from the payment gateway for the payment. This message is gateway-dependent.
- `gatewayResponseCode` (string, optional) — The code returned from the payment gateway for the payment. This code is gateway-dependent.
- `gatewayState` (enum, optional) — The status of the payment in the gateway; specifically used for reconciliation.
  - Allowed values: `Submitted`, `NotSubmitted`, `Settled`, `FailedToSettle`
- `id` (string, optional) — The ID of the payment chargeback.
- `markedForSubmissionOn` (string, optional) — The date and time when a charge was marked and waiting for batch submission to the payment process, in `yyyy-mm-dd hh:mm:ss` format.
- `methodType` (enum, optional) — How an external refund was issued to a customer.
  - Allowed values: `ACH`, `Cash`, `Check`, `CreditCard`, `PayPal`, `WireTransfer`, `DebitCard`, `CreditCardReferenceTransaction`, `BankTransfer`, `Other`
- `number` (string, optional) — The unique identification number of the payment. For example, P-00000001.
- `organizationLabel` (string, optional) — The organization that this object belongs to. Note: This field is available only when the Multi-Org feature is enabled.
- `paymentId` (string, optional) — The ID of the payment that is refunded.
- `paymentMethodId` (string, optional) — The unique ID of the payment method that the customer used to make the payment.
- `paymentMethodSnapshotId` (string, optional) — The unique ID of the payment method snapshot which is a copy of the particular Payment Method used in a transaction.
- `payoutId` (string, optional) — The payout ID from the gateway side.
- `reasonCode` (string, optional) — A code identifying the reason for the transaction.
- `referenceId` (string, optional) — The transaction ID returned by the payment gateway for an electronic refund. Use this field to reconcile refunds between your gateway and Zuora Payments.
- `refundDate` (date, optional) — The date when the refund takes effect, in `yyyy-mm-dd` format. For example, 2017-03-01.
- `refundTransactionTime` (string, optional) — The date and time when the refund was issued, in `yyyy-mm-dd hh:mm:ss` format.
- `secondRefundReferenceId` (string, optional) — The transaction ID returned by the payment gateway if there is an additional refund.
- `settledOn` (string, optional) — The date and time when the transaction is settled, in `yyyy-mm-dd hh:mm:ss` format.
- `softDescriptor` (string, optional) — A payment gateway-specific field that maps Zuora to other gateways.
- `softDescriptorPhone` (string, optional) — A payment gateway-specific field that maps Zuora to other gateways.
- `status` (string, optional) — The status of the payment.
- `submittedOn` (string, optional) — The date and time when the payment was submitted, in yyyy-mm-dd hh:mm:ss format.
- `success` (boolean, optional) — Returns `true` if the request was processed successfully.
- `type` (enum, optional) — The type of the payment.
  - Allowed values: `External`, `Electronic`
- `updatedById` (string, optional) — The ID of the Zuora user who last updated the payment.
- `updatedDate` (string, optional) — The date and time when the payment was last updated, in `yyyy-mm-dd hh:mm:ss` format. For example, 2019-03-02 15:36:10.

## Errors

### 500 Internal Server Error

Internal Server Error

- `reasons` (list of ErrorResponseReasonsItems, optional)

### 400 Client Request Error

Request Errors

- `processId` (string, optional) — The ID of the process that handles the operation.
- `reasons` (list of CommonResponseReasonsItems, optional) — The container of the error code and message. This field is available only if the `success` field is `false`.
- `requestId` (string, optional) — Unique identifier of the request.
- `success` (boolean, optional) — Indicates whether the call succeeded.

## Types

### PostRejectPaymentResponseFinanceInformation

Container for the finance information related to the refund.

- `bankAccountAccountingCode` (string, optional) — The accounting code that maps to a bank account in your accounting system.
- `bankAccountAccountingCodeType` (string, optional) — The type of the accounting code that maps to a bank account in your accounting system.
- `transferredToAccounting` (enum, optional) — Whether the refund was transferred to an external accounting system. Use this field for integration with accounting systems, such as NetSuite.
  - Allowed values: `Processing`, `Yes`, `No`, `Error`, `Ignore`
- `unappliedPaymentAccountingCode` (string, optional) — The accounting code for the unapplied payment.
- `unappliedPaymentAccountingCodeType` (string, optional) — The type of the accounting code for the unapplied payment.

### ErrorResponseReasonsItems

- `code` (string, optional) — The error code of response.
- `message` (string, optional) — The detail information of the error response

### CommonResponseReasonsItems

- `code` (string, optional) — The error code of response.
- `message` (string, optional) — The detail information of the error response

## Examples

**Request**

```json
{
  "gatewayReconciliationReason": "insufficient_funds"
}
```

**Response**

```json
{
  "accountId": "8ad09bce83f1da020183f97e245c1c47",
  "amount": 10,
  "comment": null,
  "createdById": "8ad084a67f9c7138017fab8a8b511b5a",
  "createdDate": "2024-11-01 17:27:08",
  "financeInformation": {
    "transferredToAccounting": "Processing",
    "unappliedPaymentAccountingCode": "Accounts Receivable",
    "unappliedPaymentAccountingCodeType": "AccountsReceivable"
  },
  "gatewayState": "Settled",
  "id": "8ad0875992e093310192e70ccaa0589b",
  "methodType": "CreditCard",
  "number": "R-00000026",
  "paymentId": "8ad0987e92e0a44a0192e646f4de27b1",
  "paymentMethodId": "8ad09bce83f1da020183f97e24821c4b",
  "reasonCode": "Payment Rejection",
  "refundDate": "2024-11-01",
  "settledOn": "2024-11-01 17:27:08",
  "status": "Processed",
  "success": true,
  "type": "External",
  "updatedById": "8ad084a67f9c7138017fab8a8b511b5a",
  "updatedDate": "2024-11-01 17:27:08",
  "paymentGatewayNumber": null,
  "paymentNumber": "P-00001539"
}
```

**SDK Code**

```python response
import requests

url = "https://rest.test.zuora.com/v1/gateway-settlement/payments/payment-key/reject"

payload = { "gatewayReconciliationReason": "insufficient_funds" }
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript response
const url = 'https://rest.test.zuora.com/v1/gateway-settlement/payments/payment-key/reject';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"gatewayReconciliationReason":"insufficient_funds"}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go response
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://rest.test.zuora.com/v1/gateway-settlement/payments/payment-key/reject"

	payload := strings.NewReader("{\n  \"gatewayReconciliationReason\": \"insufficient_funds\"\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby response
require 'uri'
require 'net/http'

url = URI("https://rest.test.zuora.com/v1/gateway-settlement/payments/payment-key/reject")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"gatewayReconciliationReason\": \"insufficient_funds\"\n}"

response = http.request(request)
puts response.read_body
```

```java response
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://rest.test.zuora.com/v1/gateway-settlement/payments/payment-key/reject")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"gatewayReconciliationReason\": \"insufficient_funds\"\n}")
  .asString();
```

```php response
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://rest.test.zuora.com/v1/gateway-settlement/payments/payment-key/reject', [
  'body' => '{
  "gatewayReconciliationReason": "insufficient_funds"
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp response
using RestSharp;

var client = new RestClient("https://rest.test.zuora.com/v1/gateway-settlement/payments/payment-key/reject");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"gatewayReconciliationReason\": \"insufficient_funds\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift response
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = ["gatewayReconciliationReason": "insufficient_funds"] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://rest.test.zuora.com/v1/gateway-settlement/payments/payment-key/reject")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```